.*
.* $Id: bldlevel.ipf,v 1.1 2003/10/10 11:39:39 prokushev Exp $
.*
:userdoc.

:title.Build level reference

:h1.Build level information

:p.
Any osFree executibles contains build level information string.
Usually build level placed into resources, but also can be
in code or data sections.

:p.Usual place of build level information is Description string of
DEF-file:

:p.Description '@#osFree&colon.9.23#@Control utility for ANSI'

:h1.Minimal build level information

:p.Commonly used following build level information syntax:

:p.
@#<Vendor>&colon.<Revision>#@<Description>

:p.
where <Vendor>, <Revision> and <Description> are ascii strings with
corresponding information.

:p.
Example:

:p.Description '@#osFree&colon.9.23#@Control utility for ANSI'

:h1.Extended build level information Type I

:p.
MPTN and TCP/IP services of osFree uses extended build level information.
In most cases such information not stored as Description, but as
asciiz constant string in code. This is why standard OS/2 bldlevel
tool does not work for such files. Syntax is following:

:p.
@#<Vendor>&colon.<Revision>#@##built <BuildDate> -- on <BuildHost>;0.1@@<Description>[&colon.<SubDescription>[&colon.<SubDescription>...]

:p.where
.br
.br
<BuildDate> is date and time of build
.br
<BuildHost> is machine on which build compiled
.br
<SubDescription> is closer desctiption of software pack

:p.
Example:

:p.Description '@#osFree&colon.9.23#@##build 5 Oct 2003  15&colon.00&colon.00 -- on RACERPC;0.1@@Command line tools&colon.Control utility for ANSI'

:p.

:h1.Extended build level information Type II

:p.
Another most known, and most complex, type of build level information is
following:

:p.
@#<Vendor>&colon.<Revision>#@1##<BuildHost>&colon.<ASDFeatureID>&colon.<LanguageCode>&colon.<CountryCode>&colon.<Build>&colon.<Unknown>&colon.<FixPackVer>@@<Description>

:p.
where
:p.
<BuildHost> is machine on which build compiled
.br
<ASDFeatureID> is identifier of ASD feature
.br
<LanguageCode> is code of language of component
.br
<CountryCode> is country code of component
.br
<Build> is build number
.br
<Unknown> is not known information (must be empty)
.br
<FixPackVer> is FixPack version (if distibuted as part of).

:p.
Example:

:p.Description '@#osFree&colon.9.23#@1##RACERPC&colon.0&colon.866&colon.7&colon.436&colon.&colon.WRR8706@@Control utility for ANSI'

:euserdoc.

.*
.* $Log: bldlevel.ipf,v $
.* Revision 1.1  2003/10/10 11:39:39  prokushev
.* Import
.*
.*
